var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => src_default,
  defineConfig: () => defineConfig,
  docTools: () => docTools
});
module.exports = __toCommonJS(src_exports);
var import_logger = require("@modern-js/utils/logger");
var import_chalk = __toESM(require("@modern-js/utils/chalk"));
var import_core = require("@modern-js/core");

// src/config/defineConfig.ts
var defineConfig = (config) => config;

// src/index.ts
var MODERN_CONFIG_FILES = [
  "modern.config.ts",
  "modern.config.js",
  "_meta.json"
];
var WATCH_FILE_TYPES = [".md", ".mdx", ".tsx", ".jsx", ".ts", ".js", ".json"];
var docTools = (options = {}) => ({
  name: "@modern-js/doc-tools",
  setup: (api) => __async(void 0, null, function* () {
    const appContext = api.useAppContext();
    api.setAppContext(__spreadProps(__spreadValues({}, appContext), {
      toolsType: "doc-tools"
    }));
    const { configFiles = MODERN_CONFIG_FILES, extraDocConfig = {} } = options;
    const { dev, build, serve, mergeDocConfig } = yield import("@modern-js/doc-core");
    let server;
    let startServer;
    return {
      watchFiles() {
        var _a2;
        const { configFile } = api.useAppContext();
        const config = api.useConfigContext();
        return [configFile, (_a2 = config.doc) == null ? void 0 : _a2.root, "**/_meta.json"].filter(
          Boolean
        );
      },
      fileChange(_0) {
        return __async(this, arguments, function* ({ filename, eventType }) {
          const isConfigFile = configFiles.some(
            (configFileName) => filename.endsWith(configFileName)
          );
          const isWatchFileType = WATCH_FILE_TYPES.some(
            (type) => filename.endsWith(type)
          );
          if ((isConfigFile && eventType === "change" || eventType === "add" || eventType === "unlink") && server && isWatchFileType) {
            import_logger.logger.info(
              `${import_chalk.default.green(
                filename
              )} has changed, dev server will restart...
`
            );
            yield server.close();
            yield startServer();
          }
        });
      },
      commands({ program }) {
        program.command("dev [root]").description("start the dev server").option("-c --config <config>", "specify config file").action((docRoot) => __async(this, null, function* () {
          startServer = (isFristStart = false) => __async(this, null, function* () {
            if (!isFristStart) {
              try {
                yield import_core.cli.init(import_core.cli.getPrevInitOptions());
              } catch (err) {
                console.error(err);
              }
            }
            const config = api.useConfigContext();
            const app = api.useAppContext();
            const { appDirectory } = app;
            const docConfig = mergeDocConfig(config, {
              doc: extraDocConfig
            });
            server = yield dev({
              appDirectory,
              docDirectory: docRoot || "",
              config: docConfig
            });
          });
          yield startServer(true);
        }));
        program.command("build [root]").description("build the document site for production").option("-c --config <config>", "specify config file").action((docRoot) => __async(this, null, function* () {
          const config = api.useConfigContext();
          const docConfig = mergeDocConfig(config, {
            doc: extraDocConfig
          });
          const app = api.useAppContext();
          const { appDirectory } = app;
          yield build({
            appDirectory,
            docDirectory: docRoot || "",
            config: docConfig
          });
        }));
        program.command("preview [root]").alias("serve").description("preview the production build locally").option("-c --config <config>", "specify config file").option("--port [port]", "port number").option("--host [host]", "hostname").action(
          (root, options2) => __async(this, null, function* () {
            const { port, host } = options2 || {};
            const config = api.useConfigContext();
            const docConfig = mergeDocConfig(config, {
              doc: extraDocConfig
            });
            yield serve({
              config: docConfig,
              host,
              port
            });
          })
        );
      }
    };
  })
});
var src_default = docTools;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  defineConfig,
  docTools
});
